#include <bits/stdc++.h>
using namespace std;
int counter[30],trenutni,maxi=-1,vel;
char maxslovo;
string t;
int main(){
    cin >> t;
    int vel=t.size();
    for(int i=0; i<27; i++){
    trenutni=-1;
    for(int j=0; j<t.size(); j++){
    if(t[j]=='a'+i){
        if(trenutni==-1)trenutni=j;
        else if(j-trenutni){
        for(int x=0; x<=(j-trenutni)/2; x++){
        if(t[trenutni+x]==t[j-x] && (j-x-(trenutni+x)-1)%2==0)counter[i]++;
        }
        trenutni=j;
        }
    }
    }
    }
    for(int i=0; i<27; i++){
       if(maxi<counter[i]){
        maxi=counter[i];
        maxslovo='a'+i;
       }
    }
    trenutni=-1;
    for(int j=0; j<t.size(); j++){
    if(t[j]==maxslovo){
        if(trenutni==-1)trenutni=j;
        else for(int x=1; x<=min(trenutni,vel-j-1); x++){
        if(t[trenutni-x]==t[j+x] && (j+x-(trenutni-x)-1)%2==0)maxi++;
        }
        trenutni=j;
    }
    }
    cout << maxi << endl;
    return 0;
}